﻿using System;
using System.Collections.Generic;
using System.Text;

namespace Nuane.Posterous
{
	/// <summary>
	/// An event that occurs when a chunk of data was uploaded to posterous.
	/// </summary>
	public class PosterousUploadProgressEventArgs : EventArgs
	{
		/// <summary>
		/// Gets the number of already uploaded bytes.
		/// </summary>
		/// <value>Already uploaded bytes.</value>
		public int AlreadyUploadedBytes { get; private set; }

		/// <summary>
		/// Gets the total number of bytes to upload.
		/// </summary>
		/// <value>Total bytes.</value>
		public int TotalBytes { get; private set; }

		internal PosterousUploadProgressEventArgs(int current, int total)
		{
			AlreadyUploadedBytes = current;
			TotalBytes = total;
		}
	}

}
